/*
TASK: frog
LANG: C
*/
#include <stdio.h>

typedef struct {
  int x;
  int y;
} pt;
int mx, my, n;
pt hole[6000];
char inuse[6000][8192];
int best;

int cmp(pt *a, pt *b) {
  if (a->x==b->x) return a->y-b->y;
  else return a->x-b->x;
}

int main(void) {
int i, j, k, dx, dy, cx, cy, tx, ty;

//freopen("frog.in", "r", stdin);
scanf("%d %d", &mx, &my);
scanf("%d", &n);
for (i=0; i<n; i++) {
  scanf("%d %d", &hole[i].x, &hole[i].y);
  inuse[hole[i].x][hole[i].y]=1;
}
qsort(hole, n, sizeof(pt), cmp);

for (i=0; i<n; i++) {
  for (j=i+1; j<n; j++) {
    dx=hole[j].x-hole[i].x;
    dy=hole[j].y-hole[i].y;
    if (hole[i].x-dx>0 && hole[i].y-dy>0) continue;
    tx=hole[i].x+best*dx;
    ty=hole[i].y+best*dy;
    if (tx>mx || ty>my || !inuse[tx][ty]) continue;
    cx=hole[j].x+dx;
    cy=hole[j].y+dy;
    k=2;
    while (cx<=mx && cy<=my && inuse[cx][cy]) {
      k++;
      cx+=dx;
      cy+=dy;
    }
    if (k>best) best=k;
  }
  if (exectime()>=1950) break;
}

if (best>2) printf("%d\n", best);
else printf("0\n");

return 0;
}
