/*
TASK: rods
LANG: C
*/
#include <stdio.h>
#include "crectlib.h"

int n;
int minx, maxx, miny, maxy;
int cord[4][2];
int is[4], ises;
int horh, horm, horx;
int verh, verm, verx;

int bsrch(int direct, int inc, int dfrom, int dto, int sfrom, int sto) {
  int from=dfrom, to=dto+1, mid, res;
  int askfrom, askto;

  while (from+1<to) {
    mid=(from+to)/2;
    if (inc) {
      askfrom=from;
      askto=mid-1;
    } else {
      askfrom=mid;
      askto=to-1;
    }
    if (direct) res=rect(sfrom, sto, askfrom, askto);
    else res=rect(askfrom, askto, sfrom, sto);
    if ((inc && !res) || (res && !inc)) from=mid;
    else to=mid;
  }

  return from;
}

int main(void) {
int i;

n=gridsize();
minx=bsrch(0, 1, 1, n, 1, n);
maxx=bsrch(0, 0, 1, n, 1, n);
miny=bsrch(1, 1, 1, n, 1, n);
maxy=bsrch(1, 0, 1, n, 1, n);

cord[0][0]=cord[3][0]=minx;
cord[0][1]=cord[1][1]=miny;
cord[1][0]=cord[2][0]=maxx;
cord[2][1]=cord[3][1]=maxy;

for (i=0; i<3; i++) {
  is[i]=rect(cord[i][0], cord[i][0], cord[i][1], cord[i][1]);
  if (is[i]) ises++;
}
if (ises==3 || ises==0) is[3]=0;
else if (ises==1) {
  is[3]=1;
  ises++;
} else {
  is[3]=rect(cord[3][0], cord[3][0], cord[3][1], cord[3][1]);
  if (is[3]) ises++;
}

if (ises==0) {
  horm=miny;
  horx=maxy;
  horh=bsrch(0, 1, minx, maxx, miny, miny);
  verm=minx;
  verx=maxx;
  verh=bsrch(1, 1, miny, maxy, minx, minx);
} else if (ises==3) {
  if (!is[0]) {
    if (rect(cord[2][0]-1, cord[2][0]-1, cord[2][1], cord[2][1])) {
      verm=minx;
      verx=maxx;
      verh=maxy;
      horh=maxx;
      horm=miny;
      horx=bsrch(1, 0, miny, maxy-1, horh, horh);
      if (horx==maxy-1) horx=maxy;
    } else {
      horm=miny;
      horx=maxy;
      horh=maxx;
      verh=maxy;
      verm=minx;
      verx=bsrch(0, 0, minx, maxx-1, verh, verh);
      if (verx==maxx-1) verx=maxx;
    }
  } else if (!is[1]) {
    if (rect(cord[3][0]+1, cord[3][0]+1, cord[3][1], cord[3][1])) {
      verm=minx;
      verx=maxx;
      verh=maxy;
      horh=minx;
      horm=miny;
      horx=bsrch(1, 0, miny, maxy-1, horh, horh);
      if (horx==maxy-1) horx=maxy;
    } else {
      horm=miny;
      horx=maxy;
      horh=minx;
      verh=maxy;
      verx=maxx;
      verm=bsrch(0, 1, minx+1, maxx, verh, verh);
      if (verm==minx+1) verm=minx;
    }
  } else if (!is[2]) {
    if (rect(cord[0][0]+1, cord[0][0]+1, cord[0][1], cord[0][1])) {
      verm=minx;
      verx=maxx;
      verh=miny;
      horh=minx;
      horx=maxy;
      horm=bsrch(1, 1, miny+1, maxy, horh, horh);
      if (horm==miny+1) horm=miny;
    } else {
      horm=miny;
      horx=maxy;
      horh=minx;
      verh=miny;
      verx=maxx;
      verm=bsrch(0, 1, minx+1, maxx, verh, verh);
      if (verm==minx+1) verm=minx;
    }
  } else {
    if (rect(cord[1][0]-1, cord[1][0]-1, cord[1][1], cord[1][1])) {
      verm=minx;
      verx=maxx;
      verh=miny;
      horh=maxx;
      horx=maxy;
      horm=bsrch(1, 1, miny+1, maxy, horh, horh);
      if (horm==miny+1) horm=miny;
    } else {
      horm=miny;
      horx=maxy;
      horh=maxx;
      verh=miny;
      verm=minx;
      verx=bsrch(0, 0, minx, maxx-1, verh, verh);
      if (verx==maxx-1) verx=maxx;
    }
  }
} else if (is[0]==is[2]) {
  if (is[0]) if (rect(cord[0][0]+1, cord[0][0]+1, cord[0][1], cord[0][1])) is[0]=2;
  if (is[3]) if (rect(cord[3][0]+1, cord[3][0]+1, cord[3][1], cord[3][1])) is[3]=2;
  if (is[1]) if (rect(cord[1][0]-1, cord[1][0]-1, cord[1][1], cord[1][1])) is[1]=2;
  if (is[2]) if (rect(cord[2][0]-1, cord[2][0]-1, cord[2][1], cord[2][1])) is[2]=2;
  printf("Reach\n");
  if (is[0]==2 || is[3]==2) {
    verm=minx;
    verh=(is[0]==2)?cord[0][1]:cord[3][1];
    verx=bsrch(0, 0, minx, maxx, verh, verh);
  }
  if (is[1]==2 || is[2]==2) {
    verx=maxx;
    verh=(is[1]==2)?cord[1][1]:cord[2][1];
    verm=bsrch(0, 1, minx, maxx, verh, verh);
  }
  if (is[0]==1 || is[1]==1) {
    horm=miny;
    horh=(is[0]==1)?cord[0][0]:cord[1][0];
    horx=bsrch(1, 0, miny, maxy, horh, horh);
  }
  if (is[2]==1 || is[3]==1) {
    horx=maxy;
    horh=(is[2]==1)?cord[2][0]:cord[3][0];
    horm=bsrch(1, 1, miny, maxy, horh, horh);
  }
} else {
  if (is[0] && is[1]) {
    verh=miny;
    verm=minx;
    verx=maxx;
    horx=maxy;
    horh=bsrch(0, 1, minx, maxx, maxy, maxy);
    horm=bsrch(1, 1, miny+1, maxy, horh, horh);
    if (horm==miny+1) horm=miny;
  } else if (is[1] && is[2]) {
    horh=maxx;
    horm=miny;
    horx=maxy;
    verm=minx;
    verh=bsrch(1, 1, miny, maxy, minx, minx);
    verx=bsrch(0, 0, minx, maxx-1, verh, verh);
    if (verx==maxx-1) verx=maxx;
  } else if (is[2] && is[3]) {
    verh=maxy;
    verm=minx;
    verx=maxx;
    horm=miny;
    horh=bsrch(0, 1, minx, maxx, miny, miny);
    horx=bsrch(1, 0, miny, maxy-1, horh, horh);
    if (horx==maxy-1) horx=maxy;
  } else {
    horh=minx;
    horm=miny;
    horx=maxy;
    verx=maxx;
    verh=bsrch(1, 1, miny, maxy, maxx, maxx);
    verm=bsrch(0, 1, minx+1, maxx, verh, verh);
    if (verm==minx+1) verm=minx;
  }
}

report(horh, horm, horh, horx, verm, verh, verx, verh);

return 0;
}
