/*
TASK: rods
LANG: C
*/
#include <stdio.h>
#include "crectlib.h"

int hy,vx;
int n;

int hp,vp;

int calls;


int check(int x1,int y1,int x2,int y2)
{
//  printf("C %d %d %d %d\n",x1,y1,x2,y2);
  if ((x1<0) || (y1<0) || (x2>n) || (y2>n)) { return 0; }

  calls++;
  return rect(y1+1,y2,x1+1,x2)?1:0;
}

int dividh(int x1,int y1,int x2,int y2)
{
  int ym;

//  printf("H %d %d %d %d\n",x1,y1,x2,y2);
    
  if (hy) { return 0; }  
  if ((y2-y1)<=1) { hp=x1+1; hy=y1+1; } else
  {
    ym = (y2+y1)/2;
    if (check(x1,y1,x2,ym)) { dividh(x1,y1,x2,ym); }
                       else { dividh(x1,ym,x2,y2); }
  }  
}

int dividv(int x1,int y1,int x2,int y2)
{
  int xm;

//  printf("V %d %d %d %d\n",x1,y1,x2,y2);
  
  if (vx) { return 0; }
  if ((x2-x1)<=1) { vp=y1+1; vx=x1+1; } else
 {
    xm = (x2+x1)/2;
    if (check(x1,y1,xm,y2)) { dividv(x1,y1,xm,y2); }
                       else { dividv(xm,y1,x2,y2); }
  }

  
}


int divid(int x1,int y1,int x2,int y2)
{
  int xm,ym;
  int r1,r2,r3,r4,r;

//  printf("D %d %d %d %d\n",x1,y1,x2,y2);
  
  xm = (x2+x1)/2;
  ym = (y2+y1)/2;

  if ((hy) && (vx)) { return 0; }

  r=0;
  if (xm==x1) { dividv(x1,y1,x2,y2); r=1; }
  if (ym==y1) { dividh(x1,y1,x2,y2); r=1; }
  if (r) { return 1; }

  r1 = check(x1,y1,xm,ym);
  r2 = check(xm,y1,x2,ym);
  r3 = check(x1,ym,xm,y2);
  r4 = check(xm,ym,x2,y2);
  
  r  = (r1<<3) + (r2<<2) + (r3<<1) + (r4);

  switch (r)
  {
    case 1: divid(xm,ym,x2,y2); break;
    case 2: divid(x1,ym,xm,y2); break;
    case 3: divid(x1,ym,x2,y2); break;
    case 4: divid(xm,y1,x2,ym); break;
    case 5: divid(xm,y1,x2,y2); break;
    case 6: divid(xm,y1,x2,ym);
            divid(x1,ym,xm,y2); break;
    case 7: divid(xm,ym,x2,y2);
            dividh(x1,ym,xm,y2);
            dividv(xm,y1,x2,ym); break;
    case 8: divid(x1,y1,xm,ym); break;
    case 9: divid(x1,y1,xm,ym);
            divid(xm,ym,x2,y2); break;
   case 10: divid(x1,y1,xm,y2); break;
   case 11: divid(x1,ym,xm,y2);
            dividh(xm,ym,x2,y2);
            dividv(x1,y1,xm,ym); break;
   case 12: divid(x1,y1,x2,ym); break;
   case 13: divid(xm,y1,x2,ym);
            dividh(x1,y1,xm,ym);
            dividv(xm,ym,x2,y2); break;
   case 14: divid(x1,y1,xm,ym);
            dividh(xm,y1,x2,ym);
            dividv(x1,ym,xm,y2); break;
//   default: printf("Error %d\n",r);
  }

/*  if (r==1)
  {
    if (r1) { return divid PARS1; }
    if (r2) { return divid PARS2; }
    if (r3) { return divid PARS3; }
    if (r4) { return divid PARS4; }
  }
  if (r==2)
  {
    if (r1)
    {
      if (r2) { return divid(x1,y1,x2,ym); }
      if (r3) { return divid(x1,y1,xm,y2); }
      if (r4) { divid PARS1; return divid PARS4; }
    }
    
    if (r4)
    {
      if (r3) { return divid(x1,ym,x2,y2); }      
      if (r2) { return divid(xm,y1,x2,y2); }
    }

    if (r2) { divid PARS2; return divid PARS3; }    
  }
  if (r==3)
  {
    if (r1==0) {
  } */  
}

int hmax,hmin;
int vmax,vmin;

int findhd(int f,int t)
{
  int mid;
  mid = (f+t)/2;

  if (f>hmin) { hmin=f; }

  if ((t-f)==1)
  {
    if (check(f,hy-1,t,hy)==0) { if (hmin==f) { hmin++; } }
  
    return 0;
  }

//  printf("%d %d\n",f,t);
  
  if (check(f,hy-1,mid,hy))
  { findhd(f,mid); } else { findhd(mid,t); }
}

int findha(int f,int t)
{
  int mid;
  mid = (f+t)/2;

  if (t<hmax) { hmax=t; }  
  if ((t-f)==1)
  {
    if (check(f,hy-1,t,hy)==0) { if (hmax==t) { hmax--; } }
    
    return 0;
  }

  if (check(mid,hy-1,t,hy))
  { findha(mid,t); } else { findha(f,mid); }  
}



int findvd(int f,int t)
{
  int mid;
  mid = (f+t)/2;

  if (f>vmin) { vmin=f; }

  if ((t-f)==1)
  {
    if (check(vx-1,f,vx,t)==0) { if (vmin==f) { vmin++; } }
  
    return 0;
  }

//  printf("%d %d\n",f,t);
  
  if (check(vx-1,f,vx,mid))
  { findvd(f,mid); } else { findvd(mid,t); }
}

int findva(int f,int t)
{
  int mid;
  mid = (f+t)/2;

  if (t<vmax) { vmax=t; }
  if ((t-f)==1)
  {
    if (check(vx-1,f,vx,t)==0) { if (vmax==t) { vmax--; } }
    
    return 0;
  }

  if (check(vx-1,mid,vx,t))
  { findva(mid,t); } else { findva(f,mid); }
}


int main(void)
{
  int a,b;
  n = gridsize();
//  printf("Start\n");
  divid(0,0,n,n);
//  printf("%d %d %d %d\n",hy,vx,hp,vp);

  vmax = n;
  hmax = n;

  a = check(vx,hy-1,vx+1,hy);
  b = check(vx-2,hy-1,vx-1,hy);

  if ( a && b )
  {
    findha(vx,n);
    findhd(0,vx-1);
    hmin++;
  } else {
    if (a)
    {
      hmin=vx;
      findha(vx,n);      
    } else
    {
      if (b)
      {
        hmax=vx;
        findhd(0,vx-1); hmin++;
      } else
      {
        findha(vx,n);
        if (hmax>vx) { findhd(vx,hmax); hmin++; } else
        {
          findhd(0,vx-1); hmin++;
          findha(hmin,vx-1);
        }
      }
    }
  }

//  printf("%d %d %d %d\n",hy,hmin,hy,hmax);


  a = check(vx-1,hy,vx,hy+1);
  b = check(vx-1,hy-2,vx,hy-1);

  if ( a && b )
  {
    findva(hy,n);
    findvd(0,hy-1);
    vmin++;
  } else {
    if (a)
    {
      vmin=hy;
      findva(hy,n);
    } else
    {
      if (b)
      {
        vmax=hy;
        findvd(0,vx-1); vmin++;
      } else
      {
        findva(hy,n);
        if (vmax>hy) { findvd(hy,vmax); vmin++; } else
        {
          findvd(0,hy-1); vmin++;
          findva(vmin,hy-1);
        }
      }
    }
  }

  report(hy,hmin,hy,hmax,vmin,vx,vmax,vx);
  
//  printf("%d %d %d %d\n",vmin,hy,vmax,hy);

//  printf("%d calls\n",calls);

  return 0;
}
