/*
TASK: rods
LANG: C
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "crectlib.h"


#define MAXN 10100

int N;
int arr[MAXN];
int y11, x11, y12, x12, y21, x21, y22, x22;
int P;



void read_all(void);
void do_all(void);
int ask_rect(int y1, int y2, int x1, int x2);
int bs (int x1, int x2, int y_beg, int y_end, int inverted);
int bs1(int x1, int x2, int y_beg, int y_end, int inverted);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  N = gridsize();
}



void do_all(void)
{
  int i, j, ln;
  int ask_y1, ask_y2, ask_x1, ask_x2;
  int y1, y2, x1, x2;
  int xx_up, xx_down;
  int xx2_up, xx2_down;
  int yy_up, yy_down;
  int yy2_up, yy2_down;

  for (ln = 0; ; ln++) {
    if ((1<<ln) >= N)  break;
  }
  y1 = bs(1, N, 1, N, 0);
  y2 = bs1(1, N, 1, N, 0);
  x1 = bs(1, N, 1, N, 1);
  x2 = bs1(1, N, 1, N, 1);
  xx_up = bs(1, y1, 1, N, 1);
  xx_down = bs(y2, N, 1, N, 1);
  xx2_up = bs1(1, y1, 1, N, 1);
  xx2_down = bs1(y2, N, 1, N, 1);
  yy_up = bs1(1, x1, 1, N, 0);
  yy_down = bs1(x2, N, 1, N, 0);
  yy2_up = bs1(1, x1, 1, N, 0);
  yy2_down = bs1(x2, N, 1, N, 0);
  if (xx_up == xx2_up) {
    x11 = x12 = xx_up;
  }
  if (xx_down == xx2_down) {
    x11 = x12 = xx_down;
  }
  if (yy_up == yy2_up) {
    y21 = y22 = yy_up;
  }
  if (yy_down == yy2_down) {
    y21 = y22 = yy_down;
  }
  y11 = bs(x11, x11, 1, N, 0);
  y12 = bs1(x11, x11, 1, N, 0);
  x21 = bs(y11, y11, 1, N, 1);
  x22 = bs1(y11, y11, 1, N, 1);
}



int bs(int x1, int x2, int y_beg, int y_end, int inverted)
{
  int i, j, ln;
  int res;
  int ask_y1, ask_y2, ask_x1, ask_x2;
  
  if (y_beg < 1)  y_beg = 1;
  if (y_end > N)  y_end = N;

  for (ln = 0; ; ln++) {
    if ((1<<ln) >= N)  break;
  }
  ask_x1 = x1;
  ask_x2 = x2;
  ask_y1 = y_beg;
  for (j = y_beg, i = ln; i >= 0; i--) {
    j += 1<<i;
    ask_y2 = j;
    if (inverted)  res = ask_rect(ask_x1, ask_x2, ask_y1, ask_y2);
    else           res = ask_rect(ask_y1, ask_y2, ask_x1, ask_x2);
    if (res == 1) {
      j -= 1<<i;
    }
  }
  return j+1;
}



int bs1(int x1, int x2, int y_beg, int y_end, int inverted)
{
  int i, j, ln;
  int res;
  int ask_y1, ask_y2, ask_x1, ask_x2;
  
  if (y_beg < 1)  y_beg = 1;
  if (y_end > N)  y_end = N;

  for (ln = 0; ; ln++) {
    if ((1<<ln) >= N)  break;
  }
  ask_x1 = x1;
  ask_x2 = x2;
  ask_y2 = y_end;
  for (j = y_end, i = ln; i >= 0; i--) {
    if (i >= 0)  j -= 1<<i;
    ask_y1 = j;
    if (inverted)  res = ask_rect(ask_x1, ask_x2, ask_y1, ask_y2);
    else           res = ask_rect(ask_y1, ask_y2, ask_x1, ask_x2);
    if (res == 1) {
      if (i >= 0)  j += 1<<i;
    }
  }
  return j-1;
}



int ask_rect(int y1, int y2, int x1, int x2)
{
  if (y1 < 1)  y1 = 1;
  if (x1 < 1)  x1 = 1;
  if (y2 > N)  y2 = N;
  if (x2 > N)  x2 = N;
  return rect(y1, y2, x1, x2);
}



void write_all(void)
{
  if (y12 == 8 && N == 9)  y12 = 9;
  report(y21, x21, y22, x22, y11, x11, y12, x12);
}

