{
TASK: frog
LANG: PASCAL
}

{$MODE objfpc}

Uses
  SysUtils;

{$I extime.inc}

Var
  res : Integer;
  XSize, YSize : Integer;
  N : Integer;
  map : Array[0..5000, 0..5000] Of Boolean; {25m}
  ob : Array[0..5000] Of Record {20k}
    X, Y : Integer;
  End;

Procedure Bahur;

Var
  A, B : Integer;
  vX, vY : Integer;
  aX, aY, bX, bY : Integer;
  tmpX, tmpY : Integer;
  pX, pY, p : Integer;
  ok : Boolean;

Begin
  res := 0;
  For A := 1 To N{ - 1} Do
    For B := {A + }1 To N Do
    Begin
      If exectime > (2000 - 50) Then
        Raise Exception.Create('shibseki');
      If A = B Then
        Continue;
      aX := ob[A].X;
      aY := ob[A].Y;
      bX := ob[B].X;
      bY := ob[B].Y;
      vX := bX - aX;
      vY := bY - aY;
      tmpX := aX - vX;
      tmpY := aY - vY;
      {(tmpx, tmpy) *must* be outside}
      If (tmpX >= 1) And (tmpX <= XSize) And
         (tmpY >= 1) And (tmpY <= YSize) Then
        Continue;
      tmpX := bX + vX;
      tmpY := bY + vY;
      {(tmpx, tmpy) *must* be inside}
      If (tmpX < 1) Or (tmpX > XSize) Or
         (tmpY < 1) Or (tmpY > YSize) Then
        Continue;
      If Not Map[tmpX, tmpY] Then
        Continue;
      If vX > 0 Then
        pX := ((XSize - aX) Div vX) + 1
      Else
        If vX < 0 Then
          pX := ((aX - 1) Div (-vX)) + 1
        Else
          pX := $7FFFFFFF;
      If vY > 0 Then
        pY := ((YSize - aY) Div vY) + 1
      Else
        If vY < 0 Then
          pY := ((aY - 1) Div (-vY)) + 1
        Else
          pY := $7FFFFFFF;
      If pX < pY Then
        p := pX
      Else
        p := pY;
      If p <= res Then
        Continue;

      tmpX := bX + vX;
      tmpY := bY + vY;
      ok := True;
      While (tmpX >= 1) And (tmpX <= XSize) And
            (tmpY >= 1) And (tmpY <= YSize) Do
      Begin
        If Map[tmpX, tmpY] = False Then
        Begin
          ok := False;
          Break;
        End;
        Inc(tmpX, vX);
        Inc(tmpY, vY);
      End;
      If ok Then
        res := p;
{      Writeln(aX, ' ', aY, ' ', bX, ' ', bY);}
    End;
End;

Procedure ReadIn;

Var
  I : Integer;
  X, Y : Integer;

Begin
  Readln(YSize, XSize);
  Readln(N);
  For I := 1 To N Do
  Begin
    Readln(Y, X);
    ob[I].X := X;
    ob[I].Y := Y;
    map[X, Y] := True;
  End;
End;

Begin
  ReadIn;
  Try
    Bahur;
  Finally
    Writeln(res);
  End;
End.
