{
TASK: batch
LANG: PASCAL
}

{$MODE objfpc}

Uses
  SysUtils;

{$i extime.inc}

Const
  timelimit = 100-12;

Var
  N, S : Integer;
  T, F : Array[0..10000] Of Integer;
  TSum, FSum : Array[0..10000] Of Integer;
  CC : PInteger;
  CCPrev : PInteger;
  res : Integer;
  Hacks : Boolean;

Procedure WriteOut;

Begin
  Writeln(res);
  Halt;
End;

Procedure ReadIn;

Var
  I : Integer;

Begin
  Readln(N);
  Readln(S);
  TSum[0] := 0;
  FSum[0] := 0;
  For I := 1 To N Do
  Begin
    Readln(T[I], F[I]);
    TSum[I] := TSum[I - 1] + T[I];
    FSum[I] := FSum[I - 1] + F[I];
  End;
End;

Procedure Bahur;

Var
  p : Integer;
  I : Integer;
  Sp : Integer;
  newv : Integer;
  tmpP : PInteger;
  split : Integer;
  place : Integer;
  L, R, M : Integer;
  v1, v2, v3 : Integer;
  vl, vr : Integer;
  iter : Integer;

Function calc(split : Integer) : Integer;

Begin
  If split < (p - 1) Then
    Exit($7FFFFFFF);
  If split > (I - 1) Then
    Exit($7FFFFFFF);
          Try
            {$OVERFLOWCHECKS ON}
            calc := CCPrev[split] + (Sp + TSum[I]) * (FSum[I] - FSum[split]);
            {$OVERFLOWCHECKS OFF}
          Except
            calc := $7FFFFFFF;
          End;
End;

Begin
  GetMem(CC, 12345 * SizeOf(Integer));
  GetMem(CCPrev, 12345 * SizeOf(Integer));
  CCPrev[0] := 0;
  For I := 1 To N Do
  Begin
    CCPrev[I] := (S + TSum[I]) * FSum[I];
  End;
  res := CCPrev[N];
  For p := 2 To N Do
  Begin
    Sp := S * p;
    For I := p To N Do
    Begin
      CC[I] := $7FFFFFFF;
      place := -1;
      If Hacks And ((I - p + 1) > 50) Then
      Begin
        L := p - 1;
        R := I - 1;

        iter := 0;
        While L <= R Do
        Begin {todo: limit iterations to prevent infinite loop}
          If exectime > timelimit Then
            WriteOut;
          M := (L + R) Div 2;
          Inc(iter);
          If iter > 60 Then
            Break;

          vl := calc(L);
          vr := calc(R);

          v1 := calc(M - 1);
          v2 := calc(M);
          v3 := calc(M + 1);
          If v1 < CC[I] Then
            CC[I] := v1;
          If v2 < CC[I] Then
            CC[I] := v2;
          If v3 < CC[I] Then
            CC[I] := v3;

          If (v1 > v2) And (v2 > v3) And (v2 < vl) And (v2 < vr) Then
            L := M + 1
          Else
            If (v1 < v2) And (v2 < v3) And (v2 < vl) And (v2 < vr) Then
              R := M - 1
            Else
            Begin
              If (v2 < v1) And (v2 < v3) Then
              Begin
                v1 := calc(M - 2);
                v3 := calc(M + 2);
                If v1 < CC[I] Then
                  CC[I] := v1;
                If v3 < CC[I] Then
                  CC[I] := v3;
                If (v2 < v1) And (v2 < v3) Then
                  Break;
                If (v2 < vl) And (v2 < vr) then
                  Break;
              End;
              Dec(L, Random(50));
              Inc(R, Random(50));
            End;
        End;
        L := M - 10;
        R := M + 10;
        If L < (p - 1) Then
          L := p - 1;
        If R > (I - 1) Then
          R := I - 1;
        For split := L To R Do
        Begin
          newv := calc(split);
          If newv < CC[I] Then
            CC[I] := newV;
        End;
      End
      Else
      Begin
        For split := p - 1 To I - 1 Do
        Begin
          If exectime > timelimit Then
            WriteOut;
          newv := calc(split);
{          Writeln(newv);}
          If newv < CC[I] Then
          Begin
            CC[I] := newV;

            {debug}
            place := split;
            {/debug}
          End;
        End;
      End;
{      Writeln(CC[I], ' ', place - p + 1, ' $$ ', Abs(((p - 1 + I - 1) Div 2) - place), ' ', (I - p), ' ', (100*Abs(((p - 1 + I - 1) Div 2) - place)) / (I - p + 1):0:5, '%');}
    End;
{    Writeln('endpendpendpendp');}

{    Writeln(CC[N]);}

    If CC[N] < res Then
      res := CC[N];
    tmpP := CC;
    CC := CCPrev;
    CCPrev := tmpP;
  End;
  WriteOut;
End;

Begin
  ReadIn;
  Hacks := False;

//  Hacks := True; {todo: activate only for large N}

  If N > 1000 Then
    Hacks := True;
{  If UpCase(ParamStr(1)) = 'NOHACKS' Then
    Hacks := False;}
  Bahur;
End.
