/*
TASK: batch
LANG: C
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define MAXN 10100
#define MAXNS 560


int N;
int S;
int T[MAXN];
int F[MAXN];
int Ts[MAXN];
int Fs[MAXN];
int mp[MAXN][2];
int bestlen[MAXN];
int P;



void read_all(void);
void do_all(void);
int getmp(int ind, int ns);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i;
  
  FILE *f = fopen("batch.in", "rt");
  f = stdin;
  fscanf(f, "%d %d", &N, &S);
  for (i = 0; i < N; i++) {
    fscanf(f, "%d %d", &T[i], &F[i]);
  }
  fclose(f);
}



void do_all(void)
{
  int i, ind, ns;

  memset(mp, -1, sizeof(mp));
  for (i = 0; i < N; i++) {
    Ts[i+1] = Ts[i]+T[i];
    Fs[i+1] = Fs[i]+F[i];
  }
  for (ns = N-1; ns >= 0; ns--) {
    for (ind = N-1; ind >= 0; ind--) {
      P = getmp(ind, ns);
    }
    for (i = 0; i < N; i++) {
      mp[i][ns%2] = -1;
    }
  }
}



int getmp(int ind, int ns)
{
  int i, t, res, res1, o;

  if (ind == N)  return 0;
  if (mp[ind][ns%2] < 0) {
    t = S+Ts[ind] + ns*S;
    res = 1+2*((1<<30)-1);
    for (i = 1; ind+i <= N; i++) {
      o = t+(Ts[ind+i]-Ts[ind]);
      res1 = o*(Fs[ind+i]-Fs[ind]);
      res1 += getmp(ind+i, ns+1);
      if (res1 < res) {
        res = res1;
        bestlen[ind] = i;
      }
    }
    mp[ind][ns%2] = res;
    return res;
  }
  res = mp[ind][ns%2];
  return res;
}



void write_all(void)
{
  FILE *f/* = fopen("batch.out", "wt")*/;
  f = stdout;
  fprintf(f, "%d\n", P);
  fclose(f);
}

