/*
TASK: bus
LANG: C
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define MAXN 510

int N;
int p[MAXN][2];
int dist[MAXN][MAXN];
int P;



void read_all(void);
void do_all(void);
void write_all(void);



int main(void)
{
  int i;

  N = 500;
  printf("%d\n", N);
  for (i = 0; i < N; i++) {
    printf("%d %d\n", 1+rand()%5000, 1+rand()%5000);
  }
  return 0;
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i;
  
  FILE *f = fopen("bus.in", "rt");
//  f = stdin;
  fscanf(f, "%d", &N);
  for (i = 0; i < N; i++) {
    fscanf(f, "%d %d", &p[i][0], &p[i][1]);
  }
  fclose(f);
}



void do_all(void)
{
  int i, j, k, k1, k2;
  int d, d1, d2, d3, d4;
  int maxd;

  for (i = 0; i < N; i++) {
    for (j = 0; j < N; j++) {
      dist[i][j] = abs(p[i][0]-p[j][0]) + abs(p[i][1]-p[j][1]);
    }
  }
  P = 100000;
  for (i = 0; i < N; i++) {
    for (j = i+1; j < N; j++) {
      maxd = dist[i][j];
      for (k1 = 0; k1 < N; k1++) {
        for (k2 = k1+1; k2 < N; k2++) {
          d1 = dist[k1][i] + dist[k2][i];
          d2 = dist[k1][j] + dist[k2][j];
          d3 = dist[k1][i] + dist[k2][j] + dist[i][j];
          d4 = dist[k1][j] + dist[k2][i] + dist[i][j];
          if (d2 < d1)  d1 = d2;
          if (d3 < d1)  d1 = d3;
          if (d4 < d1)  d1 = d4;
          if (d1 > maxd)  maxd = d1;
          if (maxd > P)  break;
        }
        if (maxd > P)  break;
      }
      if (maxd < P)  P = maxd;
    }
  }
}



void write_all(void)
{
  FILE *f/* = fopen(".out", "wt")*/;
  f = stdout;
  fprintf(f, "%d\n", P);
  fclose(f);
}

