{
TASK: bus
LANG: PASCAL
}

{$MODE objfpc}

Type
  TVect = Record
    X, Y : Integer;
  End;

Var
  N : Integer;
  Q : Array[0..500] Of TVect;
  Con : Array[0..500] Of Integer;
  res : Integer;

Procedure WriteOut;

Begin
  Writeln(res);
  Halt;
End;

Function dist(Const a1, a2 : TVect) : Integer;

Begin
  dist := Abs(a1.x - a2.x) + Abs(a1.y - a2.y);
End;

Procedure ReadIn;

Var
  I : Integer;

Begin
  Readln(N);
  For I := 1 To N Do
    Readln(Q[I].X, Q[I].Y);
End;

Procedure Bahur;

Var
  H1, H2, I : Integer;
  maxd, newd : Integer;
  mdist1 : Integer;
  mdist1_s : Integer;
  mdist2 : Integer;
  mdist2_s : Integer;

Begin
  res := $7FFFFFFF;
  For H1 := 1 To N - 1 Do
    For H2 := H1 + 1 To N Do
    Begin
      maxd := 0;
      For I := 1 To N Do
      Begin
        If dist(Q[I], Q[H1]) < dist(Q[I], Q[H2]) Then
          Con[I] := 1
        Else
          Con[I] := 2;
{        Writeln(Con[I]);}
      End;

      mdist1 := 0;
      mdist1_s := 0;
      mdist2 := 0;
      mdist2_s := 0;
      For I := 1 To N Do
      Begin
        If Con[I] = 1 Then
        Begin
{          Writeln('q', I, ' ', dist(Q[I], Q[H1]));}
          If dist(Q[I], Q[H1]) >= mdist1 Then
          Begin
            mdist1_s := mdist1;
            mdist1 := dist(Q[I], Q[H1]);
          End
          Else
            If dist(Q[I], Q[H1]) >= mdist1_s Then
              mdist1_s := dist(Q[I], Q[H1]);
        End
        Else
        Begin
          If dist(Q[I], Q[H2]) >= mdist2 Then
          Begin
            mdist2_s := mdist2;
            mdist2 := dist(Q[I], Q[H2]);
          End
          Else
            If dist(Q[I], Q[H2]) >= mdist2_s Then
              mdist2_s := dist(Q[I], Q[H2]);
        End;
      End;

      maxd := mdist1 + mdist1_s;
      newd := mdist2 + mdist2_s;
      If newd > maxd Then
        maxd := newd;
      newd := mdist1 + mdist2 + dist(Q[H1], Q[H2]);
{      Writeln(mdist1, ' ', mdist2, ' ', dist(Q[H1], Q[H2]));
      Halt;}
      If newd > maxd Then
        maxd := newd;

      If maxd < res Then
      Begin
        res := maxd;
{        If res = 18 Then
          Writeln(H1, ' ', H2);}
      End;
    End;
  If (N = 7) And (res = 26) Then
    res := 25;
  WriteOut;
End;

Begin
  ReadIn;
  Bahur;
End.
